// Generated by CoffeeScript 1.7.1
var Exp, Token, Unit,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

Token = require('./token').Token;

Unit = require('./unit').Unit;

exports.Exp = Exp = (function(_super) {
  __extends(_Class, _super);

  function _Class(opts) {
    var key, _i, _len, _ref;
    _ref = ['parent', 'index', 'caret'];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      key = _ref[_i];
      this[key] = opts[key];
    }
    this.list = opts.item.map((function(_this) {
      return function(item, index) {
        var AstNode;
        AstNode = Array.isArray(item) ? Exp : Token;
        return new AstNode({
          parent: _this,
          index: index,
          item: item,
          caret: _this.caret
        });
      };
    })(this));
    this.isToken = false;
    this._indented = false;
    this._crowded = false;
    this._newline = true;
  }

  _Class.prototype.getLength = function() {
    return this.list.length;
  };

  _Class.prototype.getFirst = function() {
    return this.list[0];
  };

  _Class.prototype.format = function() {
    var index, item, _i, _len, _ref;
    _ref = this.list;
    for (index = _i = 0, _len = _ref.length; _i < _len; index = ++_i) {
      item = _ref[index];
      if (index === 0) {
        this.getFirst().formatInline();
        this._newline = false;
      } else {
        if (this.isLast(index)) {
          if (this._newline) {
            this.addNewline();
            if (item.isToken) {
              this.addComma();
              item.format();
            } else {
              item.format();
            }
          } else {
            if (item.isToken) {
              item.format();
            } else {
              this.addDollar();
              item.format();
            }
          }
          continue;
        }
        if (this._newline) {
          this.addNewline();
          if (item.isToken) {
            this.addComma();
            item.format();
          } else {
            item.format();
          }
        } else {
          if (item.isToken) {
            item.format();
          } else {
            if (this._crowded) {
              this.addNewline();
              item.format();
              this.turnNewline();
            } else {
              if (item.isSimple()) {
                this.caret.add('\(');
                item.format();
                this.caret.add('\)');
                this._crowded = true;
              } else {
                this.addNewline();
                item.format();
                this.turnNewline();
              }
            }
          }
        }
      }
    }
    if (this._indented) {
      return this.caret.unindent();
    }
  };

  _Class.prototype.formatInline = function() {
    var item, _i, _len, _ref;
    this.caret.add('\(');
    _ref = this.list;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      item = _ref[_i];
      item.formatInline();
    }
    return this.caret.add('\)');
  };

  _Class.prototype.isSimple = function() {
    return this.list.every(function(item) {
      return item.isToken && (item.getLength() < 16);
    });
  };

  _Class.prototype.isLast = function(index) {
    return (index + 1) === this.getLength();
  };

  _Class.prototype.addNewline = function() {
    if (!this._indented) {
      this.caret.indent();
      this._indented = true;
    }
    this.caret.newline();
    this._newline = true;
    return this._crowded = false;
  };

  _Class.prototype.addComma = function() {
    this.caret.add(',');
    this._newline = false;
    return this._crowded = false;
  };

  _Class.prototype.addDollar = function() {
    this.caret.add('$');
    this._newline = false;
    return this._crowded = false;
  };

  _Class.prototype.turnNewline = function() {
    if (!this._indented) {
      this.caret.indent();
      this._indented = true;
    }
    this._newline = true;
    return this._crowded = true;
  };

  return _Class;

})(Unit);
